	' !!IMPORTANT!!
	' YOU MUST HAVE WRITE PERMISSIONS TO THE LOCATIONS DEFINED BELOW FOR THE TEMP,DEBUG, AND PRICE FILE
	' YOU MUST UPDATE THE 'strRootFolder' VARIABLE TO POINT TO THE ROOT FOLDER OF YOUR MAGIC ALBUM APPLICATION INSTALL
	' !!IMPORTANT!!

	' !!NOTE!!
	' THIS SCRIPT SUPPORTS ARGUMENTS, YOU MAY PASS THE FOLLOWING ARGUMENTS IN TO SET VARIABLES ACCORDINGLY
	' IF ARGUMENT IS NOT PASSED TO SCRIPT, DEFAULTS ARE USED (LISTED BELOW)
	' SETNAME,BLOCKNAME,DEBUGMODE,ROOTFOLDER,VERIFYBEFOREADD,TEMPFILE,DEBUGFILE,PRICEFILE,VERBOSEMODE,FORMAT
	' EXAMPLE:
	' capefeargames.vbs format="standard" cardfoiling="nonfoil" language="english" setname="ALL" blockname="ALL" debugmode="off" rootfolder="c:\magic album" verifybeforeadd="yes" tempfile="c:\sitetemp.txt" debugfile="c:\sitedebug.txt" pricefile="c:\siteprice.txt" verbosemode="off" 
	' !!NOTE!!
	
	
	Set Args = WScript.Arguments
	Dim strRunTime,strLanguageToCollect,strCardFoilingToCollect,strVerifyBeforeAdd,strBlockNameToCollect,strSetNameToCollect,strFormatToCollect,strUserInput,strStartTime,strEndTime,strDebugMode,ArrPageCount(),ArrSetName(),ArrSetURL(),ArrBlock(),ArrFormat(),ArrStandardFormatSets,ArrExtendedFormatSets,strScriptVersion,strSiteName,strVerboseMode,strRootFolder,strCatalogTempFile,strTempFile,strDebugFile,strPriceFile,strSiteURLHeader,strCatalogURL
	ArrStandardFormatSets = Array("Dark Ascension","Innistrad","Magic 2012","New Phyrexia","Mirrodin Besieged","Scars of Mirrodin")
	ArrExtendedFormatSets = Array("Magic 2011","Rise of the Elrazi","Worldwake","Zendikar","Magic 2010","Alara Reborn","Conflux","Shards of Alara")
	strScriptVersion = "1.2"
	strSiteName = "FindMagicCards"
	strVerboseMode = "off"	'off,on
	strDebugMode = "off"
	strRootFolder = "..\"
	strCatalogTempFile = strRootFolder & strSiteName & "_catalog.tmp"
	strTempFile = strRootFolder & strSiteName & "_webdata.tmp"
	strDebugFile = strRootFolder & strSiteName & "_debug.tmp"
	strPriceFile = strRootFolder & strSiteName & ".txt"
	strCatalogURL = "http://bidwicket.com/Category/Collectible_Card_Games/Magic_the_Gathering/Singles.html"
	strSiteURLHeader = "http://bidwicket.com"
	strSetNameToCollect = "none"
	strFormatToCollect = "standard"	'standard,extended
	strBlockNameToCollect = "none"
	strVerifyBeforeAdd = "yes"	'yes,no
	strCardFoilingToCollect = "nonfoil"
	strLanguageToCollect = "english"

	strStartTime = Now()
	DefineGlobalArguments
	If Not LCase(strVerboseMode) = "off" Then
		strUserInput = MsgBox("Verify you have opened the script in a command window otherwise popups between sets will occur and require user interaction." & vbCrLf & vbCrLf & "Do you wish to continue?",36,"Warning - Verbose Mode [" & UCase(strVerboseMode) & "]")
		If strUserInput = 7 Then : WScript.Quit : End If
	End If
	
	If (LCase(strSetNameToCollect) = "all") Or (LCase(strBlockNameToCollect) = "all") Then
		strUserInput = MsgBox("Setting either set name or block name to collect all information can take a substancial amount of time." & vbCrLf & vbCrLf & "Do you wish to continue?",36,"Warning - Set/Blocks to collect set to [ALL]")
		If strUserInput = 7 Then : WScript.Quit : End If
	End If
	If Not Right(strRootFolder,1) = "\" Then : strRootFolder = strRootFolder & "\" : End If
	DeclareKnownSets
	VerifyPreRequirementsExist "yes"
	IdentifyAvailableSiteSets strCatalogTempFile,strCatalogURL
	DumpArrayInformation
	CollectCardInformation strTempFile,strCardFoilingToCollect,strLanguageToCollect,strPriceFile
	PostProcesses
	strEndTime = Now()
	strRunTime = DateDiff("n",strStartTime,strEndTime)
	If LCase(strVerboseMode) = "on" Then : WScript.Echo "It took [" & strRunTime & "] minutes to collect all the data" : End If


	Sub VerifyPreRequirementsExist(strRecreate)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Verifying Pre-Requirements" : End If
		'declare objects
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		
		'verify required folder exists
		If Not objFileSys.FolderExists(strRootFolder) Then
			MsgBox "Root folder [" & strRootFolder & "] does not exist, please verify",vbOKOnly,"Error"
			WScript.Quit
		End If
		
		'verify required files exist
		If LCase(strRecreate) = "yes" Then
			If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Recreated required files" : End If
			objFileSys.CreateTextFile strCatalogTempFile
			objFileSys.CreateTextFile strTempFile
			objFileSys.CreateTextFile strDebugFile
			objFileSys.CreateTextFile strPriceFile
		Else
			If Not objFileSys.FileExists(strCatalogTempFile) Then : objFileSys.CreateTextFile strCatalogTempFile : End If
			If Not objFileSys.FileExists(strTempFile) Then : objFileSys.CreateTextFile strTempFile : End If
			If Not objFileSys.FileExists(strDebugFile) Then : objFileSys.CreateTextFile strDebugFile : End If
			If Not objFileSys.FileExists(strPriceFile) Then : objFileSys.CreateTextFile strPriceFile : End If
		End If
		
		'free object memory
		Set objFileSys = Nothing
		
	End Sub

	Sub DumpArrayInformation()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		For i = 0 To UBound(ArrSetName)
			WriteLog strDebugFile,"ArrPageCount(" & i & ") = " & """" & ArrPageCount(i) & """" & " : ArrSetName(" & i & ") = " & """" & ArrSetName(i) & """" & " : ArrSetURL(" & i & ") = " & """" & ArrSetURL(i) & """" & " : ArrBlock(" & i & ") = " & """" & ArrBlock(i) & """" & " : ArrFormat(" & i & ") = " & """" & ArrFormat(i) & """","no"
		Next
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Set information dumped to debug file" : End If
	End Sub

	Sub DeclareKnownSets()
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Populating predefined product information" : End If
		Dim intNewArraySize
		intNewArraySize = 0
		
		'declare set array information
		Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)

		' Example: 
		'	Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
		'	ArrPageCount(intNewArraySize) = 21 : ArrSetName(intNewArraySize) = "Magic 2012" : ArrSetURL(intNewArraySize) = "magic_singles-core_sets-magic_2012/702" : ArrBlock(intNewArraySize) = "Core Sets" : ArrFormat(intNewArraySize) = "Standard" : intNewArraySize = UBound(arrPageCount) + 1
		
		'--core sets
		'--innistrad block
		'--scars of mirrodin block
		'--zendikar block
		'--shares of alara block
		'--shadowmoor block
		'--lorwyn block
		'--time spiral block
		'--ravnica block
		'--kamigawa block
		'--mirrodin block
		'--onslaught block
		'--odyssey block
		'--invasion block
		'--masques block
		'--saga block
		'--tempest block
		'--ice age block
		'--mirage block
		'--stand alone sets
		'--special editions
		'--magic promos
		'--premium deck series
		'--duel decks
		'--from the vault
		
	End Sub
	
	Function VerifyFolderExists(strFolder,strCreate)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim objFileSys,strResults
		strResults = "Unknown"
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		Select Case LCase(strCreate)
			Case "yes"
				If NOT objFileSys.FolderExists(strFolder) Then : objFileSys.CreateFolder strFolder : End If
				If Err.Number = 0 Then : strResults = "DoesExist" : Else : strResults = "DoesNotExist" : End If
			Case Else
				strResults = "DoesNotExist"
		End Select
		Set objFileSys = Nothing
		VerifyFolderExists = strResults
	End Function
	
	Function HTTPDownload(myURL, strFile)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim i, objFile, objFSO, objHTTP, strResults
		strResults = "failed"
		Const ForReading = 1, ForWriting = 2, ForAppending = 8
		Set objFSO = CreateObject( "Scripting.FileSystemObject" )
		Set objFile = objFSO.OpenTextFile( strFile, ForWriting, True )
	    	Set objHTTP = CreateObject( "WinHttp.WinHttpRequest.5.1" )
		objHTTP.Open "GET", myURL, False
		objHTTP.Send
		For i = 1 To LenB( objHTTP.ResponseBody )
			objFile.Write Chr( AscB( MidB( objHTTP.ResponseBody, i, 1 ) ) )
		Next
		objFile.Close( )
		strResults = "success"
		HTTPDownload = strResults
	End Function
	
	Sub WriteLog(strLogFile,strDataToWrite,strRecreate)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim objFileSys,objFileOpenForAppending
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		If LCase(strRecreate) = "delete" Then
			If objFileSys.FileExists(strLogFile) Then
				objFileSys.DeleteFile strLogFile,True
			End If
		Else
			If NOT objFileSys.FileExists(strLogFile) Then : objFileSys.CreateTextFile strLogFile : End If
			If (LCase(strRecreate) = "yes") Then : objFileSys.CreateTextFile strLogFile : End If
			Set objFileOpenForAppending = objFileSys.OpenTextFile(strLogFile,8)
			objFileOpenForAppending.WriteLine strDataToWrite
			objFileOpenForAppending.Close
			Set objFileOpenForReading = Nothing
		End If
	End Sub

	Function IdentifyAvailableSiteSets(strCatalogTempFile,strCatalogURL)
		If Not LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Identifying Site Product Information" : End If
		
		'declare variables
		Dim strIdentifiedBlock,strSetKnown,intNewArraySize,strIdentifiedPageCount,strIdentifiedFormats,strResults,objFileSys,objFileOpenForReading,strCurrentReadLine,colCurrentLineSplitOne,colCurrentLineSplitTwo,strIdentifiedSetName,strIdentifiedSetURL
				
		'download catalog files
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Downloading product catalog information" : End If
		strResults = HTTPDownload(strCatalogURL,strCatalogTempFile)
		If LCase(strResults) = "success" Then
			'declare object(s)
			Set objFileSys = CreateObject("Scripting.FileSystemObject")
			
			'parse catalog file content
			If objFileSys.FileExists(strCatalogTempFile) Then
				Set objFileOpenForReading = objFileSys.OpenTextFile(strCatalogTempFile,1)
				Do While objFileOpenForReading.AtEndOfStream <> True
					strCurrentReadLine = objFileOpenForReading.ReadLine
					If Not LCase(strCurrentReadLine) = "" Then
						If InStr(LCase(strCurrentReadLine),LCase("/Singles/")) Then
							If InStr(LCase(strCurrentReadLine),LCase("<!--")) Or InStr(LCase(strCurrentReadLine),LCase("catarrow.gif")) Then
								'do nothing
							Else
								'identify available set name
								colCurrentLineSplitOne = Split(strCurrentReadLine,"</a>")
								colCurrentLineSplitTwo = Split(colCurrentLineSplitOne(0),">")
								strIdentifiedSetName = colCurrentLineSplitTwo(UBound(colCurrentLineSplitTwo))
								strIdentifiedSetName = CorrectSetName(strIdentifiedSetName)
						
								'identify available set url
								colCurrentLineSplitOne = Split(strCurrentReadLine,"'>")
								colCurrentLineSplitTwo = Split(colCurrentLineSplitOne(0),"'")
								strIdentifiedSetURL = strSiteURLHeader & colCurrentLineSplitTwo(UBound(colCurrentLineSplitTwo))
								
								'identify set format
								strIdentifiedFormats = IdentifySetFormat(strIdentifiedSetName)
							
								'determin if the set is already known
								strSetKnown = VerifyIfSetIsInArray(strIdentifiedSetName)
								
								If LCase(strSetKnown) = "no" Then
									If Not LCase(strIdentifiedSetName) = ""  Then
										If LCase(strIdentifiedSetName) = LCase(strSetNameToCollect) Then
											'collect more details about the set
											strIdentifiedPageCount = IdentifySetPageCount(strIdentifiedSetName,strIdentifiedSetURL)
											strIdentifiedBlock = IdentifyBlockInformation(strIdentifiedSetName)
											intNewArraySize = UBound(ArrSetName) + 1
											Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
											ArrPageCount(intNewArraySize) = strIdentifiedPageCount : ArrSetName(intNewArraySize) = strIdentifiedSetName : ArrSetURL(intNewArraySize) = strIdentifiedSetURL : ArrBlock(intNewArraySize) = strIdentifiedBlock : ArrFormat(intNewArraySize) = strIdentifiedFormats
										Else
											If LCase(strSetNameToCollect) = "all" Then
												'collect more details about the Set
												strIdentifiedPageCount = IdentifySetPageCount(strIdentifiedSetName,strIdentifiedSetURL)
												strIdentifiedBlock = IdentifyBlockInformation(strIdentifiedSetName)
												
												'add set information into known sets array for processing
												intNewArraySize = UBound(ArrSetName) + 1
												Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
												ArrPageCount(intNewArraySize) = strIdentifiedPageCount : ArrSetName(intNewArraySize) = strIdentifiedSetName : ArrSetURL(intNewArraySize) = strIdentifiedSetURL : ArrBlock(intNewArraySize) = strIdentifiedBlock : ArrFormat(intNewArraySize) = strIdentifiedFormats
											Else
												If LCase(strBlockNameToCollect) = LCase(strIdentifiedBlock) Then
													'collect more details about the set
													strIdentifiedPageCount = IdentifySetPageCount(strIdentifiedSetName,strIdentifiedSetURL)
													strIdentifiedBlock = IdentifyBlockInformation(strIdentifiedSetName)
													
													'add set information into known sets array for processing
													intNewArraySize = UBound(ArrSetName) + 1
													Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
													ArrPageCount(intNewArraySize) = strIdentifiedPageCount : ArrSetName(intNewArraySize) = strIdentifiedSetName : ArrSetURL(intNewArraySize) = strIdentifiedSetURL : ArrBlock(intNewArraySize) = strIdentifiedBlock : ArrFormat(intNewArraySize) = strIdentifiedFormats
												Else
													If LCase(strBlockNameToCollect) = "all" Then
														'collect more details about the set
														strIdentifiedPageCount = IdentifySetPageCount(strIdentifiedSetName,strIdentifiedSetURL)
														strIdentifiedBlock = IdentifyBlockInformation(strIdentifiedSetName)
														
														'add set information into known sets array for processing
														intNewArraySize = UBound(ArrSetName) + 1
														Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
														ArrPageCount(intNewArraySize) = strIdentifiedPageCount : ArrSetName(intNewArraySize) = strIdentifiedSetName : ArrSetURL(intNewArraySize) = strIdentifiedSetURL : ArrBlock(intNewArraySize) = strIdentifiedBlock : ArrFormat(intNewArraySize) = strIdentifiedFormats
													Else
														If InStr(LCase(strIdentifiedFormats),LCase(strFormatToCollect)) Then
															'collect more details about the set
															strIdentifiedPageCount = IdentifySetPageCount(strIdentifiedSetName,strIdentifiedSetURL)
															strIdentifiedBlock = IdentifyBlockInformation(strIdentifiedSetName)
															
															'add set information into known sets array for processing
															intNewArraySize = UBound(ArrSetName) + 1
															Redim Preserve ArrPageCount(intNewArraySize) : Redim Preserve ArrSetName(intNewArraySize) : Redim Preserve ArrSetURL(intNewArraySize) : Redim Preserve ArrBlock(intNewArraySize) : Redim Preserve ArrFormat(intNewArraySize)
															ArrPageCount(intNewArraySize) = strIdentifiedPageCount : ArrSetName(intNewArraySize) = strIdentifiedSetName : ArrSetURL(intNewArraySize) = strIdentifiedSetURL : ArrBlock(intNewArraySize) = strIdentifiedBlock : ArrFormat(intNewArraySize) = strIdentifiedFormats
														End If
													End If
												End If
											End If
										End If							
									End If
								End If
							End If
						End If
					End If
				Loop
				objFileOpenForReading.Close
				Set objFileOpenForReading = Nothing
			End If
			
			'clear declared object memory
			Set objFileSys = Nothing
		End If
	
		'return results
		IdentifyAvailableSiteSets = strResults

	End Function
	
	Function CorrectSetName(strSetName)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		Dim strResults,colSetNameSplit
		strResults = ""
		
		'corrent set name spacing
		If InStr(LCase(strSetName),"&nbsp;") Then
			colSetNameSplit = Split(strSetName,"&nbsp;")
			For Each Item In colSetNameSplit
				If strResults = "" Then
					strResults = Item
				Else
					strResults = strResults & " " & Item
				End If
			Next
		Else
			strResults = strSetname
		End If
		
		'remove any unwanted identified set names
		If InStr(strResults,"(") Then : strResults = "" : End If
		If InStr(strResults,"$") Then : strResults = "" : End If
		
		'correct set names incorrectly typed on page
		Select Case strResults
			Case "Premium Deck Series: Fire and ..." : strResults = "Premium Deck Series: Fire and Lightning"
			Case "Duel Decks: Phyrexia vs The Co..." : strResults = "Duel Decks: Phyrexia vs The Coalition"
			Case "Magic 2010 Core Set" : strResults = "Magic 2010"
			Case "Magic 2011 Core Set" : strResults = "Magic 2011"
			Case "Magic 2012 Core Set" : strResults = "Magic 2012"
			Case Else
		End Select
		
		'return results
		CorrectSetName = strResults	
	End Function
	
	Function IdentifySetFormat(strSetToIdentify)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If	
		Dim strResults
		strResults = "Unknown"

		Select Case LCase(strSetToIdentify)
			Case "unglued"
			Case "unhinged"
			Case Else
				'check if set is in known standard set list
				If InStr(LCase(strResults),"standard") Then
					'do nothing, the set is already marked as in standard format
				Else
					For Each strSet In ArrStandardFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Standard"
							Else
								strResults = strResults & ",Standard"
							End If
							Exit For
						End If
					Next
				End If
				
				'check if set is in known extended set list
				If InStr(LCase(strResults),"extended") Then
					'do nothing, the set is already marked as in extended format
				Else
					For Each strSet In ArrStandardFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Extended"
							Else
								strResults = strResults & ",Extended"
							End If
							Exit For
						End If
					Next
					
					For Each strSet In ArrExtendedFormatSets
						If LCase(strSet) = LCase(strSetToIdentify) Then
							If LCase(strResults) = "unknown" Then
								strResults = "Extended"
							Else
								strResults = strResults & ",Extended"
							End If
							Exit For
						End If
					Next
				End If 
				
				'apply vintage & legacy
				If LCase(strResults) = "unknown" Then : strResults = "Legacy,Vintage" : Else : strResults = strResults & ",Legacy,Vintage" : End If
		
		End Select
				
		'return results
		IdentifySetFormat = strResults
		
	End Function

	Function IdentifySetPageCount(strSetName,strSetURL)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "-->Identifying [" & strSetName & "] page count" : End If
		Dim strResults,objFileSys,objFileOpenForReading,strCurrentReadLine
		strResults = 1	'there is only 1 page per set on findmagiccards.com / bidwicket
		IdentifySetPageCount = strResults
	End Function
	
	Function VerifyIfSetIsInArray(strSetName)
		If Not LCase(strDebugFile) = "on" Then : On Error Resume Next : End If
		Dim strResults
		strResults = "no"
		For Each Item In ArrSetName
			If LCase(strSetName) = LCase(Item) Then
				strResults = "yes"
				Exit For
			End If
		Next
		VerifyIfSetIsInArray = strResults
	End Function
	
	Sub DefineGlobalArguments()
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim colArgumentSplit
		For Each Argument in Args
			If InStr(Argument,"=") Then
				'define passed in argument variable information
				If InStr(LCase(Argument),LCase("setname=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strSetNameToCollect = CorrectSetName(colArgumentSplit(1))
					End If
				End If

				If InStr(LCase(Argument),LCase("blockname=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strBlockNameToCollect = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("debugmode=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strDebugMode = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("rootfolder=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strRootFolder = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("verifybeforeadd=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strVerifyBeforeAdd = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("tempfile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strTempFile = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("debugfile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strDebugFile = colArgumentSplit(1)
					End If
				End If

				If InStr(LCase(Argument),LCase("pricefile=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strPriceFile = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("verbosemode=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strVerboseMode = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("language=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strLanguageToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("cardfoiling=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strCardFoilingToCollect = colArgumentSplit(1)
					End If
				End If
				
				If InStr(LCase(Argument),LCase("format=")) Then
					colArgumentSplit = Split(Argument,"=")
					If UBound(colArgumentSplit) > 0 Then
						strFormatToCollect = colArgumentSplit(1)
					End If
				End If
				
			Else
				'improperly formated argument passed
			End If
		Next
	End Sub

	Sub CollectCardInformation(strTempFileToUse,strFoilOrNonFoil,strCardLanguage,strOutPutFileToUse)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Collecting detailed set information" : End If
		Dim strDoesCardAlreadyExistInFile,strCardVersion,intLocatedCardValueLength,strLocatedCardValue,strLocatedCardName,colCurrentCardBlockSplitTwo,colCurrentCardBlockSplitOne,strResults,strCardBlock,strCardBlockOpenString,strCardBlockEndString,strOpenBlockFound,strCloseBlockFound
		strCardBlock = ""
		strCardBlockOpenString = "<TD colspan=6 align=left valign=top>"
		strCardBlockEndString = "<TD colspan=3 align=right valign=top>"
		strOpenBlockFound = False
		strCloseBlockFound = False
		
		'process sets to collect card information for
		For i = 0 To UBound(ArrSetName)
			If Not (ArrSetName(i) = "") Then
				
				'download detailed set information
				If LCase(strVerboseMode) = "on" Then : WScript.Echo "{*}Downloading [" & ArrSetName(i) & "] details on (" & Now() & ")" : End If
				strResults = HTTPDownload(ArrSetURL(i),strTempFileToUse)
				If LCase(strResults) = "success" Then
					Set objFileSys = CreateObject("Scripting.FileSystemObject")
					If objFileSys.FileExists(strTempFileToUse) Then
						If LCase(strVerboseMode) = "on" Then : WScript.Echo "--->Processing [" & ArrSetName(i) & "] details on (" & Now() & ")" : End If
						Set objFileOpenForReading = objFileSys.OpenTextFile(strTempFileToUse,1)
						Do While objFileOpenForReading.AtEndOfStream <> True
							'read in current file line
							strCurrentReadLine = objFileOpenForReading.ReadLine
			
							'locate card pricing block opening string in collected data
							If InStr(strCurrentReadLine,strCardBlockOpenString) Then : strOpenBlockFound = True : End If
			
							'append read in line to card block code IF open block string found
							If strOpenBlockFound = True Then
								strCardBlock = strCardBlock & strCurrentReadLine
				
								'locate card pricing block closing string in collected data
								If InStr(strCurrentReadLine,strCardBlockEndString) Then : strCloseBlockFound = True : End If
							End If
			
							'process card pricing block
							If strCloseBlockFound = True Then
			
								'process card block for card name
								colCurrentCardBlockSplitOne = Split(strCardBlock,"</a>")
								If UBound(colCurrentCardBlockSplitOne) > 1 Then
									colCurrentCardBlockSplitTwo = Split(colCurrentCardBlockSplitOne(0),">")
									strLocatedCardName = Trim(colCurrentCardBlockSplitTwo(UBound(colCurrentCardBlockSplitTwo)))
									colCurrentCardBlockSplitOne = Split(strLocatedCardName,"(")
									strLocatedCardName = Trim(colCurrentCardBlockSplitOne(0))
									If InStr(strLocatedCardName,"=") Then : strLocatedCardName = "" : End If
								End If
			
								'process card block for card price
								colCurrentCardBlockSplitOne = Split(strCardBlock,"</a>")
								If UBound(colCurrentCardBlockSplitOne) > 0 Then
									colCurrentCardBlockSplitTwo = Split(colCurrentCardBlockSplitOne(1),"$")
									strLocatedCardValue = Trim(colCurrentCardBlockSplitTwo(UBound(colCurrentCardBlockSplitTwo)))
									If InStr(strLocatedCardValue,"$") Then
										intLocatedCardValueLength = Len(strLocatedCardValue)
										strLocatedCardValue = Right(strLocatedCardValue,intLocatedCardValueLength - 1)
									End If
									If InStr(strLocatedCardValue,"-") Then
										intLocatedCardValueLength = Len(strLocatedCardValue)
										strLocatedCardValue = Right(strLocatedCardValue,intLocatedCardValueLength - 1)
									End If
									If InStr(strLocatedCardValue,"=") Then : strLocatedCardValue = "" : End If
								End If
			
								'write collected card data to file
								If NOT strLocatedCardName = "" Then
									strLocatedCardName = CorrectCardNames(strLocatedCardName)
									If Not strLocatedCardValue = "" Then
			
										'locate card version
										strCardVersion = IdentifyCardVersion(strLocatedCardName,ArrSetName(i))
						
										'write located card information out to file
										If LCase(strVerifyBeforeAdd) = "yes" Then
											strDoesCardAlreadyExistInFile = LocateStringInFile(strOutPutFileToUse,strLocatedCardName & vbtab & strLocatedCardValue & vbtab & ArrSetName(i) & vbtab & strCardLanguage & vbtab & strCardVersion & vbtab & strFoilOrNonFoil)
											If Not LCase(strDoesCardAlreadyExistInFile) = "yes" Then
												WriteLog strOutPutFileToUse,strLocatedCardName & vbtab & strLocatedCardValue & vbtab & ArrSetName(i) & vbtab & strCardLanguage & vbtab & strCardVersion & vbtab & strFoilOrNonFoil,"no"
											End If
										Else
											WriteLog strOutPutFileToUse,strLocatedCardName & vbtab & strLocatedCardValue & vbtab & ArrSetName(i) & vbtab & strCardLanguage & vbtab & strCardVersion & vbtab & strFoilOrNonFoil,"no"
										End If
									End If
								End If
				
								'clear current card block for next cards information
								strOpenBlockFound = False
								strCloseBlockFound = False
								strCardBlock = ""
								strLocatedCardName = ""
								strLocatedCardValue = ""
								strCardVersion = ""
								strDoesCardAlreadyExistInFile = ""
							End If
						Loop
						objFileOpenForReading.Close
						Set objFileOpenForReading = Nothing
					End If
					Set objFileSys = Nothing
				End If
			End If
		Next
	End Sub
	
	Sub PostProcesses()
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "Performing cleanup routine(s)" : End If
		Dim objFileSys
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		
		'remove temporary files
		If objFileSys.FileExists(strCatalogTempFile) Then : objFileSys.DeleteFile strCatalogTempFile : End If
		If objFileSys.FileExists(strTempFile) Then : objFileSys.DeleteFile strTempFile : End If
		If objFileSys.FileExists(strDebugFile) Then : objFileSys.DeleteFile strDebugFile : End If
		
		'clear used object memory
		Set objFileSys = Nothing
	End Sub
	
	Function IdentifyBlockInformation(strSetName)
		If Not LCase(strDebugMode) = "on" Then : On Error Resume Next : End If
		If LCase(strVerboseMode) = "on" Then : WScript.Echo "-->Identifying [" & strSetName & "] block information" : End If
		Dim strResults
		strResults = ""		
		'there is no way to determin block information from site, manual entry would be required
		IdentifyBlockInformation = strResults
	End Function	

	Function IdentifyCardVersion(strCardName,strCardSet)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim strResults
		strResults = "*"
		Select Case LCase(strCardName)
			Case Else
		End Select
		IdentifyCardVersion = strResults
	End Function
	
	Function LocateStringInFile(strFile,strStringToLocate)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim strResults,objFileSys,objFileOpenForReading,strCurrentReadLine
		strResults = "NO"
		Set objFileSys = CreateObject("Scripting.FileSystemObject")
		If objFileSys.FileExists(strFile) Then
			Set objFileOpenForReading = objFileSys.OpenTextFile(strFile,1)
			Do While objFileOpenForReading.AtEndOfStream <> True
				strCurrentReadLine = objFileOpenForReading.ReadLine
				If InStr(LCase(strCurrentReadLine),LCase(strStringToLocate)) Then
					strResults = "YES"
					Exit Do
				End If
			Loop
			objFileOpenForReading.Close
			Set objFileOpenForReading = Nothing
		End If
		Set objFileSys = Nothing
		If strResults = "" Then : strResults = "NO" : End If
		LocateStringInFile = strResults
	End Function
	
	Function CorrectCardNames(strCardNameToCorrect)
		If LCase(strDebugMode) = "off" Then : On Error Resume Next : End If
		Dim strResults
		strResults = ""
		If strResults = "" Then
			Select Case LCase(strCardNameToCorrect)
				Case "huntmaster of the fells" : strResults = "Huntmaster of the Fells|Ravager of the Fells"
				Case "lambholt elder" : strResults = "Lambholt Elder|Silverpelt Werewolf"
				Case "seance" : strResults = "Sance"
				Case "elbrus, the binding blade" : strResults = "Elbrus, the Binding Blade|Withengar Unbound"
				Case "loyal cathar" : strResults = "Loyal Cathar|Unhallowed Cathar"
				Case "trackers instincts" : strResults = "Trackers Instincts"
				Case "scorned villager" : strResults = "Scorned Villager|Moonscarred Werewolf"
				Case "soul seizer" : strResults = "Soul Seizer|Ghastly Haunting"
				Case "hinterland hermit" : strResults = "Hinterland Hermit|Hinterland Scourge"
				Case "mondronen shaman" : strResults = "Mondronen Shaman|Tovolars Magehunter"
				Case "chosen of markov" : strResults = "Chosen of Markov|Markovs Servant"
				Case "afflicted deserter" : strResults = "Afflicted Deserter|Werewolf Ransacker"
				Case "chalice of life" : strResults = "Chalice of Life|Chalice of Death"
				Case "ravenous demon" : strResults = "Ravenous Demon|Archdemon of Greed"
				Case "wolfbitten captive" : strResults = "Wolfbitten Captive|Krallenhorde Killer"
				Case "spite // malice" : strResults = "Spite|Malice"
				Case "pain // suffering" : strResults = "Pain|Suffering"
				Case "rise // fall" : strResults = "Rise|Fall"
				Case "wax / wane" : strResults = "Wax|Wane"
				Case "order / chaos" : strResults = "Order|Chaos"
				Case "assault / battery" : strResults = "Assault|Battery"
				Case "fire / ice" : strResults = "Fire|Ice"
				Case "jtun grunt" : strResults = "Jotun Grunt"
				Case "sapseep forest" : strResults = "Sapseep Forest"
				Case "leechridden swamp" : strResults = "Leechridden Swamp"
				Case "misty rainforest" : strResults = "Misty Rainforest"
				Case "cloistered youth" : strResults = "Cloistered Youth|Unholy Fiend"
				Case "bloodline keeper" : strResults = "Bloodline Keeper|Lord of Lineage"
				Case "screeching bat" : strResults = "Screeching Bat|Stalking Vampire"
				Case "garruk relentless" : strResults = "Garruk Relentless|Garruk, the Veil-Cursed"
				Case "daybreak ranger" : strResults = "Daybreak Ranger|Nightfall Predator"
				Case "gatstaf shepherd" : strResults = "Gatstaf Shepherd|Gatstaf Howler"
				Case "villagers of estwald" : strResults = "Villagers of Estwald|Howlpack of Estwald"
				Case "grizzled outcasts" : strResults = "Grizzled Outcasts|Krallenhorde Wantons"
				Case "mayor of avabruck" : strResults = "Mayor of Avabruck|Howlpack Alpha"
				Case "ulvenwald mystics" : strResults = "Ulvenwald Mystics|Ulvenwald Primordials"
				Case "nezumi graverobber" : strResults = "Nezumi Graverobber|Nighteyes the Desecrator"
				Case "tormented pariah" : strResults = "Tormented Pariah|Rampaging Werewolf"
				Case "delver of secrets" : strResults = "Delver of Secrets|Insectile Aberration"
				Case "instigator gang" : strResults = "Instigator Gang|Wildblood Pack"
				Case "kruin outlaw" : strResults = "Kruin Outlaw|Terror of Kruin Pass"
				Case "civilized scholar" : strResults = "Civilized Scholar|Homicidal Brute"
				Case "hanweir watchkeep" : strResults = "Hanweir Watchkeep|Bane of Hanweir"
				Case "village ironsmith" : strResults = "Village Ironsmith|Ironfang"
				Case "thraben sentry" : strResults = "Thraben Sentry|Thraben Militia"
				Case "ludevic's test subject" : strResults = "Ludevics Test Subject|Ludevics Abomination"
				Case "reckless waif" : strResults = "Reckless Waif|Merciless Predator"
				Case Else
					strResults = strCardNameToCorrect
					If InStr(LCase(strCardNameToCorrect),"forest") Then : strResults = "Forest" : End If
					If InStr(LCase(strCardNameToCorrect),"mountain") Then : strResults = "Mountain" : End If
					If InStr(LCase(strCardNameToCorrect),"plain") Then : strResults = "Plains" : End If
					If InStr(LCase(strCardNameToCorrect),"island") Then : strResults = "Island" : End If
					If InStr(LCase(strCardNameToCorrect),"swamp") Then : strResults = "Swamp" : End If
			End Select
		End If
		If strResults = "" Then : strResults = strCardNameToCorrect : End If
		CorrectCardNames = strResults
	End Function
